package com.ic.modules.auth.controller;

import java.util.Map;

import javax.validation.Valid;

import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataIntegrityViolationException;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.ic.annotation.AuditLogs;
import com.ic.constant.LeaderCalcConfig;
import com.ic.constant.StatusCode;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.L1slabsMapping;
import com.ic.modules.auth.model.MpbMapping;
import com.ic.modules.auth.payload.L1slabsDto;
import com.ic.modules.auth.payload.mpbDto;
import com.ic.modules.auth.payload.request.ApiResponse;
import com.ic.modules.auth.payload.request.Apiresponse1;
import com.ic.modules.auth.service.L1slabsMappingService;
import com.ic.modules.auth.service.LeaderCalcService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController 
@RequestMapping("/api/v1")
@Api(description = "Leader Calc API")

public class LeaderCalc {

	@Autowired
	 LeaderCalcService leaderCalcService;
	LeaderCalcConfig LeaderCalcConfig;
	 @PostMapping(value = "/leaderCalculation", headers = "Accept=application/json")
	    @ApiOperation("Create leadercalc")
	   @AuditLogs(isRequest = true, isResponse = true,service="leadercalc")
	
	 //Neel – 20-Apr-2020 – Tata - Leader calculation – Added method for calculation of leader sheet
	 public ResponseEntity<?> Calculate(@RequestBody Map<String, Object> lookupRequestObject) throws JsonProcessingException {
	    	System.out.println("in fyc contrroler");
	    	System.out.println("in fycmapping");
	    	 ObjectMapper mapper = new ObjectMapper();
	    	 
	    	 String data = mapper.writeValueAsString(lookupRequestObject);
	    
	    
	    	JSONObject calc = null;
	    
	    	
	    	try {
	    		System.out.println("in try");
	    		calc =  leaderCalcService.calculate(data);
	    		System.out.println("after operation calc");
	    		System.out.println(calc);
	    		
	    		

	    	}catch(ResourceNotFoundException e) {
	    		calc = new JSONObject();
	    		calc.put("Error_Code", "503");
	    		calc.put("Error_Message", "Technical Error caught while calculating");
	    		System.out.println(e);
	    		e.printStackTrace();
	    		return new ResponseEntity(new ApiResponse(StatusCode.RESOURCE_NOT_FOUND, true, "calculation failed", calc), HttpStatus.NOT_FOUND);
	    	}catch(Exception e) {
	    		
	    		calc = new JSONObject();
	    		calc.put("Error_Code", "503");
	    		calc.put("Error_Message", "Technical Error caught while calculating");
	    		e.printStackTrace();
	    		System.out.println(e);
	    		return new ResponseEntity(new ApiResponse(StatusCode.UNEXPECTED_ERROR, true, "calculation failed", calc), HttpStatus.BAD_REQUEST);
	    	}
	    	
	    	return new ResponseEntity(new ApiResponse(HttpStatus.OK.value(), true, "calculation done successfully", calc.toString()), HttpStatus.OK);
	    	//return new ResponseEntity(new ApiResponse(StatusCode.RESOURCE_EXIST, true, "USER_Already_Exist", null), HttpStatus.NOT_FOUND);
	    }
   
	
}
