package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ic.constant.DBConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.Configurations;
import com.ic.modules.auth.payload.ConfigurationsDto;
import com.ic.modules.auth.repository.ConfigurationsRepository;
import com.ic.modules.auth.service.ConfigurationsService;

@Service
public class ConfigurationsServiceImpl implements ConfigurationsService {

	@Autowired
	ConfigurationsRepository configRepo;
	
	@Autowired
	DBConfig DBConfig;
	public Configurations save(ConfigurationsDto dto,Boolean isCreate) {
		 Configurations configuration = null;
		 if(!isCreate) {
			 configRepo.findByKey(dto.getKey()).orElseThrow(()->new ResourceNotFoundException("Config","key",dto.getKey()));
		 }else {
			 configuration = new Configurations();
			 configuration.setKey(dto.getKey());
		 }
		 configuration.setValue(dto.getValue());
		 configuration.setDescription(dto.getDescription());
		 DBConfig.setValue(dto.getKey(), dto.getValue());
		 return configRepo.save(configuration);
		 
	 }
	 public List<Configurations> findAll(){
		 return configRepo.findAll();
	 }
	 public Configurations findByKey(String key) {
		 return configRepo.findByKey(key).orElseThrow(()->new ResourceNotFoundException("Config","key",key));
	 }
	 
}
