package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ic.constant.LeaderCalcConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.FycMapping;
import com.ic.modules.auth.model.MpbMapping;
import com.ic.modules.auth.payload.fycDto;
import com.ic.modules.auth.payload.mpbDto;
import com.ic.modules.auth.repository.MpbRepository;

import com.ic.modules.auth.service.MpbMappingService;


@Service
public class MpbMappingServiceImpl implements MpbMappingService{

	@Autowired
	MpbRepository mpbrepository;
	
	@Autowired
	LeaderCalcConfig LeaderCalcConfig;
	@Override
	public List<MpbMapping> findAll() {
		 return mpbrepository.findAll();

	}
	
	public MpbMapping save(mpbDto dto,Boolean isCreate) {
		
		if(!isCreate) {
			mpbrepository.findById(dto.getId()).orElseThrow(()->new ResourceNotFoundException("mpb","key",dto.getId()));
		 }
		
		MpbMapping mpbMapping = null;
		 
		mpbMapping = new MpbMapping();
		//mpbMapping.setId(dto.getId());
		mpbMapping.setDT(dto.getDT());
		mpbMapping.setL1(dto.getL1());
		mpbMapping.setL2(dto.getL2());
		mpbMapping.setDesignation(dto.getDesignation());
        mpbMapping.setMapping_DT_minimum_fyc(dto.getMapping_DT_minimum_fyc());
		
		 
		 return mpbrepository.save(mpbMapping);
	
		 
	 }
	

}
