package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ic.constant.LeaderCalcConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.FycMapping;
import com.ic.modules.auth.model.MpbMapping;
import com.ic.modules.auth.model.MsaMapping;
import com.ic.modules.auth.payload.MsaDto;
import com.ic.modules.auth.repository.MDBRepository;
import com.ic.modules.auth.repository.MsaRepository;
import com.ic.modules.auth.service.MsaMappingService;


@Service
public class MsaMappingServiceImpl implements MsaMappingService {

	@Autowired
	MsaRepository msarepo;
	@Override
	public List<MsaMapping> findAll() {
		// TODO Auto-generated method stub
		 return msarepo.findAll();
	}
	@Override
	public MsaMapping save(MsaDto dto, Boolean isCreate) {
		
		
		if(!isCreate) {
			msarepo.findById(dto.getId()).orElseThrow(()->new ResourceNotFoundException("msa","key",dto.getId()));
		 }
		
		MsaMapping msaMapping = null;
		
		msaMapping = new MsaMapping();
		
		msaMapping.setId(dto.getId());
		msaMapping.setMSA_1(dto.getMSA_1());
		msaMapping.setMSA_2(dto.getMSA_2());
		msaMapping.setMSA_3(dto.getMSA_3());
		msaMapping.setMSA_4(dto.getMSA_4());
	
		return msarepo.save(msaMapping);
	}

}
