package com.ic.modules.auth.service.impl;

import java.util.List;
import java.util.Optional;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.User;
import com.ic.modules.auth.payload.UserDto;
import com.ic.modules.auth.repository.UserRepository;
import com.ic.modules.auth.service.UserService;

@Service
@Transactional(propagation = Propagation.REQUIRES_NEW)
public class UserServiceImpl implements UserService {

    private static final Logger LOG = LoggerFactory.getLogger(UserServiceImpl.class);

    @Autowired
    private UserRepository userRepository;
    
    
	@Override
	public Page<User> findAll(Pageable pageable) {
		return userRepository.findAll(pageable);
	}
	
	@Autowired
	PasswordEncoder passwordEncoder;

	
	public User save(UserDto userDto) { 
		User user = new User();
		if(userDto.getId() != null) {
			user = userRepository.findByUserId(userDto.getId());// .orElseThrow(()-> new ResourceNotFoundException("User", "id", userDto.getId()));
		}
		user.setFirstName(userDto.getName());
		user.setEmailId(userDto.getEmail());
		user.setMobileNo(userDto.getMobileNumber());
		//user.setRole(userDto.getRole());
		user.setFailedAttemptLogin(0);
		user.setNotificationId(userDto.getNotificationId());
		user.setStatus(userDto.getStatus());
		user = userRepository.save(user);
		
		return user;
	}
	
	
//	public List<User> findByIds(List<Long> userIds){
//		return userRepository.findByUserIdIn(userIds);
//	}

	@Override
	public User save(User user) { 
		return userRepository.save(user);
	}
	
	@Override
	public User findById(String id) {
		
		User user = userRepository.findByUserId(id.trim());
        if(user == null) {
            return null;
        }
        else {
            return user;
        }
		
//		Optional<User> user = userRepository.findByUserId(id);
		
//		LOG.info("user---user----user"+user.toString());
//		
//		if(user.toString() == "Optional.empty") {
//			return null;
//		}
//		else {
//			return userRepository.findByUserId(id).orElseThrow(()->new ResourceNotFoundException("User", "id", id));
//		}
		
		//return userRepository.findById(id).orElseThrow(()->new ResourceNotFoundException("User", "id", id));
	}
	

}
	